Attribute VB_Name = "Makros_Sammlung"
Option Explicit
'lscht den Inhalt des Zwischenspeichers beim schieen des EXCEL Blattes
'das Makro mu in "DieserArbeitsmappe stehen. Nicht in einem Modul!
Private Sub Workbook_BeforeClose(Cancel As Boolean)
    Application.CutCopyMode = False
End Sub

'Datei verlassen ohne Nachfrage zum speichern
Sub Datei_verlassen_ohne_zu_speichern()
    ActiveWorkbook.Close SaveChanges:=False
End Sub

'Tabellenblatt ausblenden
Sub Blatt_ausblenden()
    Worksheets("Tabelle1").Visible = False
End Sub

'Tabellenblatt ausblenden
Sub Blatt_verstecken()

    Worksheets("Auswahl").Range("A1") = "test"
End Sub

'Tabellenblatt wieder einblenden
Sub Blatt_einblenden()
    Worksheets("Tabelle1").Visible = True
End Sub

'Alle Tabellenbltter einblenden
Sub Blaetter_alle_einblenden()

Dim i As Integer
    For i = 1 To Sheets.Count
     Sheets(i).Visible = True
    Next i
End Sub

'Alle Tabellenbltter einblenden
Sub Blaetter_alle_ausblenden()
'funktioniert nur, wenn mindestens 1 Blatt nicht geschlossen wird.(hier "Tabelle1")

Dim i As Integer
    For i = 1 To Sheets.Count
     Sheets(i).Visible = xlVeryHidden
     Sheets("Tabelle1").Visible = True
    Next i
End Sub

'verstecken des Worksheets, wird grau berdeckt. (HideWorksheet)
Public Sub Worksheet_verstecken()

    ActiveWindow.DisplayHeadings = False
    With ActiveSheet
      .Rows.Hidden = True
      .Columns.Hidden = True
      .Protect Password:="NoNo"
    End With
End Sub

'wieder anzeigen des Worksheets (ShowWorksheet)
Public Sub Worksheet_anzeigen()

    ActiveWindow.DisplayHeadings = True
    With ActiveSheet
      .Unprotect Password:="NoNo"
      .Rows.Hidden = False
      .Columns.Hidden = False
    End With
End Sub

'Alle Tabellenbltter schtzen
Sub Blaetter_alle_schuetzen()

Dim WS As Worksheet

    For Each WS In Worksheets
     WS.Protect
    Next
    'WS
End Sub

'Bei allen Tabellenblttern den Schutz aufheben
Sub Blaetter_alle_schuetzen_aufheben()

Dim WS As Worksheet

    For Each WS In Worksheets
     WS.Unprotect
    Next
    'WS
End Sub

'Makro ausfhren bei Auswahl in einer PIVOT-Tabelle
Sub Makro_ausfuehren_bei_PIVOT_Aenderung()
'    der Eintrag mu in der Tabelle stehen
'
'    Private Sub Worksheet_Calculate()
'        If Range("i6") = Range("C6") Then
'            Exit Sub
'        End If
'        Range("i6") = Range("C6")
'
'    End Sub
End Sub

'Datei ber Dialogfeld ffnen
Sub Datei_oeffnen_mit_Dialog()

'ggf. Laufwerk und Ordner als Vorgabe setzen
ChDir "\"
ChDrive "c:\"
Dim Datei As String
    
    'Das Dialogfenster
    Datei = Application.GetOpenFilename _
    ("Micrsoft Excel-Dateien (*.xls),*.xls,Textdateien (*.txt),*.txt,Add-In-Dateien (*.xla),*.xla")
    If Datei = False Then Exit Sub
    MsgBox "Ihre Auswahl:" & vbNewLine & Datei
End Sub

'Bildaufbau unterdrcken
Sub Bildaufbau_unterdrcken()
    Application.ScreenUpdating = False
End Sub

'Bildaufbau wieder eingeschalten
Sub Bildaufbau_einschalten()
    Application.ScreenUpdating = True
End Sub

'Ja Nein Abfrage
Sub Ja_Nein_Abfrage()

Dim Frage As String

    Frage = MsgBox("Sollen  die folgende Anweisung ausgefhrt werden?", vbYesNo)
    
    If Frage = vbYes Then
        MsgBox "Die Aktion wird ausgefhrt!"
    Else:
        MsgBox "Die Aktion wird nicht ausgefhrt!"
        Exit Sub
    End If
End Sub

'Code ausfhren wenn bestimmte Zelle selektiert wird.
'Diese Makro muss in die entsprechende Tabelle kopiert werden,
'nicht in ein allgemeines Modul

Private Sub Worksheet_SelectionChange(ByVal Target As Excel.Range)
    If Target.Address = "$A$1" Then MsgBox "Zelle A1 selektiert"
    If Target.Address = "$A$2" Then MsgBox "Zelle A2 selektiert"
    If Target.Address = "$A$3" Then MsgBox "Zelle A3 selektiert"
End Sub

'Prfen ob eine Datei vorhanden ist
Sub pruefen_Datei_vorhanden()

    If Dir("c:\test.xls") <> "" Then
        MsgBox "Datei vorhanden"
    Else:
        MsgBox "Datei fehlt"
    End If
End Sub

'Verschiebt die Datei bei bereinstimmung mit dem Suchbegriff in einen anderen Ordner
Sub Datei_verschieben()

Dim fs, f, f1, fc As Variant
Dim i As Integer
Dim arrDatei() As Variant
Dim varQuelle, varZiel, varDatei As Variant
Dim strSuchbegriff As String
Dim strSuchDateiname As String               '= Left(varDatei, 5)

'bei dieser bereinstimmung mit dem "strSuchDateiname" wird die Datei verschoben
strSuchbegriff = "AWSTD"

Set fs = CreateObject("Scripting.FileSystemObject")
'SuchPfad angeben
Set f = fs.GetFolder("D:\")
Set fc = f.Files

varQuelle = f
'ZielPfad angeben
varZiel = "D:\Test\"

ReDim arrDatei(1)

    i = 0
    For Each f1 In fc
        arrDatei(i) = f1.Name
        ReDim Preserve arrDatei(1 + i)
        i = i + 1
     Next
     i = 0
     ' Alle Objekte in "Datei" durchlaufen.
     For Each varDatei In arrDatei
        strSuchDateiname = Left(varDatei, 5)
        If strSuchDateiname = strSuchbegriff Then
            On Error Resume Next
            Name varQuelle & varDatei As varZiel & varDatei
            If Err > 0 Then
                Select Case Err
                Case 53:   'MsgBox "Datei nicht vorhanden!"
                Case 58:   'MsgBox "Datei existiert bereits!"
                Case Else: 'MsgBox Error
                End Select
            End If
            'Schleife verlassen.
            Exit For
        End If
     Next
End Sub

'Kopiert die Datei bei bereinstimmung mit dem Suchbegriff in einen anderen Ordner
Sub Datei_kopieren()

Dim fs, f, f1, fc As Variant
Dim i As Integer
Dim arrDatei() As Variant
Dim varQuelle, varZiel, varDatei As Variant
Dim strSuchbegriff As String
Dim strSuchDateiname As String               '= Left(varDatei, 5)

'bei dieser bereinstimmung mit dem "strSuchDateiname" wird die Datei verschoben
strSuchbegriff = "AWSTD"

Set fs = CreateObject("Scripting.FileSystemObject")
'SuchPfad angeben
Set f = fs.GetFolder("D:\")
Set fc = f.Files

varQuelle = f
'ZielPfad angeben
varZiel = "D:\Test\"

ReDim arrDatei(1)

    i = 0
    For Each f1 In fc
        arrDatei(i) = f1.Name
        ReDim Preserve arrDatei(1 + i)
        i = i + 1
    Next
    i = 0
    ' Alle Objekte in "Datei" durchlaufen.
    For Each varDatei In arrDatei
        strSuchDateiname = Left(varDatei, 5)
        If strSuchDateiname = strSuchbegriff Then
            If Dir(varZiel & varDatei) = "" Then
                FileCopy varQuelle & varDatei, varZiel & varDatei
            Else
            End If
        End If
     Next
End Sub

'listet Dateien aus einem bestimmten Ordner in einem Tabellenblatt auf
Sub Dateien_auflisten()

Dim fs, f, f1, fc As Variant
Dim i As Integer

Set fs = CreateObject("Scripting.FileSystemObject")
Set f = fs.GetFolder("c:\Gerry")
Set fc = f.Files

    i = 0
    For Each f1 In fc
        i = i + 1
        Sheets("Datei_auflisten").Cells(i, 1) = f1.Name
        Sheets("Datei_auflisten").Cells(i, 2) = FileLen(f1)
        Sheets("Datei_auflisten").Cells(i, 3) = FileDateTime(f1)
    Next
End Sub

'Datei von Festplatte lschen
Sub Datei_loeschen()

ChDir "c:\"
    Kill ("c:\temp\test.doc")
End Sub

'Dateiattribute setzen

'vbNormal    0   Normal (Voreinstellung)
'vbReadOnly  1   Schreibgeschtzt
'vbHidden    2   Versteckt
'vbSystem    4   Systemdatei
'vbArchive   32  Datei wurde seit dem letzten Speichern gendert

Sub Dateiattribut_aendern()

ChDir "C:\"
    Datei = "C:\Temp\Test.xls"
    SetAttr Datei, vbNormal
End Sub

'Daten aus Tabelle in eine Datei (*.csv) schreiben
Sub aufrufen_Tabelle_in_eine_Datei_im_csvFormat_schreiben()

    Call Tabelle_in_eine_Datei_im_csvFormat_schreiben("N:\Data xx\xx_VBA\Test\Test.csv", "Daten_in_csv")
End Sub
Public Sub Tabelle_in_eine_Datei_im_csvFormat_schreiben(tFN As String, tWS As String)

Dim nFileNr As Integer
Dim Y As Long
Dim X As Long
Dim toY As Long
Dim toX As Long
Dim tData As String
Dim v As Variant
Dim WS As Worksheet
    
Set WS = Worksheets(tWS)
v = WS.UsedRange
    
toY = UBound(v, 1)
toX = UBound(v, 2)
    
    nFileNr = FreeFile
    Open tFN For Output As #nFileNr
        For Y = 1 To toY
            tData = vbNullString
            For X = 1 To toX
                tData = tData & v(Y, X) & ";"
            Next X
            Print #nFileNr, tData
        Next Y
    Close #nFileNr
    Erase v
End Sub

'Daten aus einer Datei (*.csv) in eine Tabelle einlesen

Sub aufrufen_Daten_aus_einer_Datei_im_csvFormat_in_Tabelle_auslesen()

    Call Daten_aus_einer_Datei_im_csvFormat_in_Tabelle_auslesen("N:\Data xx\xx_VBA\Test\Test.csv", "Daten_aus_csv")
End Sub
Public Sub Daten_aus_einer_Datei_im_csvFormat_in_Tabelle_auslesen(tFN As String, tWS As String)

Dim nFileNr As Integer
Dim X As Long
Dim Y As Long
Dim toX As Long
Dim tLine As String
Dim tCells() As String
Dim WS As Worksheet
    
Const gctSeparator As String = ";"
 
Set WS = Worksheets(tWS)
    
    Y = 1
    nFileNr = FreeFile
    Open tFN For Input Access Read As #nFileNr
        While Not EOF(nFileNr)
            Line Input #nFileNr, tLine
            toX = SplitString(tLine, tCells, gctSeparator)
            If toX Then
                For X = 1 To toX
                    WS.Cells(Y, X) = tCells(X)
                Next X
                Y = Y + 1
            Erase tCells
            End If
        Wend
    Close #1
End Sub
Function SplitString(tLine As String, atPool() As String, tSeparator As String) As Long

Dim bInStr As Boolean
Dim X As Long
Dim toX As Long
Dim nCount As Long
Dim tChr As String
Dim tItem As String
    
    toX = Len(tLine)
    For X = 1 To toX
        'Zeichen isolieren
        tChr = Mid$(tLine, X, 1)
        'Trennzeichnen suchen
        If InStr(tSeparator, tChr) <> 0 Then
            If bInStr = True Then
                bInStr = False
                nCount = nCount + 1
                ReDim Preserve atPool(nCount)
                atPool(nCount) = tItem
            End If
            tItem = vbNullString
        Else
            tItem = tItem + tChr
            bInStr = True
        End If
    Next X
    
    If bInStr = True Then
        nCount = nCount + 1
        ReDim Preserve atPool(nCount)
        atPool(nCount) = tItem
    End If
    
    SplitString = nCount
End Function

'Die Prozedur KillFiles kann wie folgt aufgerufen werden
Sub aufrufen_Dateien_eines_Pfades_loeschen()

Dim lKilledFiles As Long
        
    lKilledFiles = KillFiles("*.csv", "C:\gerry\")
End Sub
Function KillFiles(FileName As String, LookIn As String) As Long

Dim i As Integer
    
    With Application.FileSearch
        .FileName = FileName
        .LookIn = LookIn
        .FileType = msoFileTypeAllFiles
        .SearchSubFolders = True
        If .Execute() > 0 Then
            For i = 1 To .FoundFiles.Count
                Call Kill(.FoundFiles(i))
            Next i
        End If
        KillFiles = .FoundFiles.Count
    End With
End Function

'Nur ungeschtzte Zellen knnen angesprungen werden.
'Der Blattschutz muss gesetzt sein und einige Zellen ungeschtzt
Sub nur_ungeschuetzte_Zellen_anspringen()

Dim Sh As Worksheet

    For Each Sh In ThisWorkbook.Worksheets
        Sh.Select
        Sh.Protect userinterfaceonly:=True        ' True
        Sh.EnableSelection = xlUnlockedCells      ' xlUnlockedCells  ==> zum aufhebnen
    Next
End Sub

'Eingabe von Werten in vorbestimmte Zellen ber eine InputBox
Sub InputBox_mehrfach_Eingabe()

Dim myRange As Range
Dim myCell As Range
Dim myAns As Variant

Set myRange = Range("e1,e2,e3")

For Each myCell In myRange.Cells
    myAns = Application.InputBox(prompt:="Bitte geben Sie die Werte in die ausgewhlten Zellen ein: " & myCell.Address, Title:="Eingabe Box")
    If myAns <> "" Then
        myCell.Value = myAns
    End If
    Next myCell
End Sub

'Eingabe von einem Wert in eine vorbestimmte Zelle ber eine InputBox
Sub InputBox_einfach_Eingabe()

Dim myRange As Range
Dim myAns As Variant

Set myRange = Range("e1")

    myAns = Application.InputBox(prompt:="Bitte geben Sie die Werte in die ausgewhlten Zellen ein: " & myRange.Address, Title:="Eingabe Box")
    myRange = myAns
    
End Sub

'Bereich ab einer bestimmten Zelle in einer Spalte,
'bis zum letzten Eintrag in dieser Spalte markieren
Sub Benutzten_Bereich_markieren()

Dim lngLetzteZeile As Long

lngLetzteZeile = Worksheets("Daten_in_csv").Range("A65536").End(xlUp).Row  ' Markieren von A3 bis An

    Worksheets("Daten_in_csv").Range(Cells(1, 1), Cells(lngLetzteZeile, 1)).Select

End Sub

'Passwortschutz fr Bltter und Arbeitsmappen aufheben

Sub Passwortschutz_aufheben()

On Error Resume Next
Dim wks As Worksheet
 
    For Each wks In Worksheets
        With wks
            .Protect vbNullString, , , , True
            .Range("A1").Copy .Range("A1")
            .Unprotect vbNullString
        End With
    Next wks
End Sub

'Die Titelleiste der Anwendung (Microsoft Excel) kann man ndern mit:
Sub Titelleiste_Anwendung_aendern()

    Application.Caption = "Blum Arbeitstechnik"
End Sub
Sub Titelleiste_Anwendung_zuruecksetzen()

    Application.Caption = Empty
End Sub

' Meldung in der StatusZeile aktivieren (...mu wieder deaktiviert werden!!)
Sub Meldung_StatusBar_ein()
 Application.StatusBar = "Hallo ich bin die Meldung in der Statuszeile"
End Sub

' Meldung deaktivieren
Sub Meldung_StatusBar_aus()
 Application.StatusBar = False
End Sub

'Die Titelleiste der Mappe kann man einrichten mit (...mu wieder deaktiviert werden!!)
Sub Meldung_Titelleiste_Mappe_aendern()

    ActiveWindow.Caption = "Beispiel: Detail der aktiven Seite"
End Sub
Sub Meldung_Titelleiste_Mappe_zuruecksetzen()

    ActiveWindow.Caption = Empty
End Sub

'Ermittelt den BenutzerNamen bzw. den AnmeldeNamen unter Windows NT/2000
Sub Benutzername_ermitteln()

Dim strUser As String
Dim strUsername As String

strUser = UCase(Environ("USERNAME"))
strUsername = Application.UserName
        
End Sub

'MsgBox verndern und mit Inhalten anzeigen
Sub MsgBox_anzeigen()

Dim Titel, Mldg_N, Mldg_J, Antwort As String
Dim stil As Long

Titel = "Arbeitstechnik"                            ' Titel definieren.
stil = vbOKOnly + vbCritical                        ' Kennzeichen definieren
Mldg_N = "Die Daten wurde nicht gespeichert!"       ' Meldung definieren.
Mldg_J = "Die Daten wurde gespeichert!"             ' Meldung definieren.

    Antwort = MsgBox(Mldg_N, stil, Titel)
   
End Sub

'Druckt das aktive Datenblatt mit benutzerdefinierten Daten aus
Sub Ausdruck_mit_benutzerdefinierten_Daten()
   
    ActiveSheet.PageSetup.LeftHeader = ""   'Kopfzeile erstellen
    ActiveSheet.PageSetup.RightHeader = _
    "Leistungskennzahlen der Arbeitstechnik. Ausdruck fr " & Application.UserName & "  " & Left(Date, 10)
    ActiveWindow.SelectedSheets.PrintOut Copies:=1, Collate:=True
    ActiveSheet.PageSetup.RightHeader = ""   'Kopfzeile lschen
End Sub
'Speichern der Datei mit voreingestelltem Namen
Sub SpeichernUnterMitvoreingestelltemDateinamen()

    ChDir ("C:\temp")
    Application.Dialogs(xlDialogSaveAs).Show "C:\temp\test.xls"
End Sub

Sub Fehlerbehandlung()
' Routine zur Fehlerbehandlung

On Error GoTo Fehlerbehandlung

  'Mglichkeit zum "produzieren" bzw. zum testen eines Laufzeitfehlers
  'Err.Raise 6

Application.ScreenUpdating = False                                                  'Bildschirmaktualisierung ausschalten

' hier steht die Prozedur
'.....
'.....

Application.ScreenUpdating = True                                                  ' Bildschirm aktualisieren

FehlerbehandlungExit:
    'sauberes Beenden / Schliessen von eventuellen Dateien u. Datenbanken
    On Error Resume Next
    'Ausstieg aus dem Programm
    Exit Sub
Fehlerbehandlung:
    Select Case Err.Number
    Case 0      'war doch kein Fehler!!!
        Resume Next
    Case Else
        MsgBox "Folgender Fehler ist aufgetreten:" & vbCrLf & _
            Err.Number & ": " & vbCrLf & Err.Description, vbExclamation
        Resume FehlerbehandlungExit
    End Select
End Sub

' Routine zur Fehlerbehandlung mit Fehlermeldungen
Sub Fehlerbehandlung_mit_Anzeige_Fehlermeldungen()

On Error GoTo Fehlerbehandlung

  Dim strModul As String
  
  strModul = ActiveWorkbook.VBProject.VBE.SelectedVBComponent.Name
  
  'Mglichkeit zum "produzieren" bzw. zum testen eines Laufzeitfehlers
  'Err.Raise 6

    Application.ScreenUpdating = False                                                  'Bildschirmaktualisierung ausschalten
    
    ' hier steht die Prozedur
    '.....
    '.....
    
    Application.ScreenUpdating = True                                                  ' Bildschirm aktualisieren


FehlerbehandlungExit:
    'sauberes Beenden / Schliessen von eventuellen Dateien u. Datenbanken
    On Error Resume Next
    'Ausstieg aus dem Programm
    Application.ScreenUpdating = True
    Windows(ThisWorkbook.Name).Visible = True
    Exit Sub
Fehlerbehandlung:
    Select Case Err.Number
    Case 0      'war doch kein Fehler!!!
        Resume Next
    Case Else
            MsgBox "Folgender Fehler ist aufgetreten:" & vbCrLf & vbCrLf & _
                    "im Modul: " & strModul & vbCrLf & _
                    "Fehlernummer: " & Err.Number & vbCrLf & _
                    "Fehlertext: " & Err.Description & vbCrLf & "" & vbCrLf & _
                    "Bitte 'FehlerDaten' notieren und Arbeitstechnik (Tel. 2586) verstndigen." & vbCrLf & _
                    "Danke." & vbCrLf & _
                    " " & vbCrLf & _
                    "......die Datei wird geschlossen!", vbOKOnly + vbCritical, "Arbeitstechnik: Fehlermeldung"
                    ActiveWorkbook.Close SaveChanges:=False

        Resume FehlerbehandlungExit
    End Select
End Sub


